
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.io
import java.lang
import java.util
import jpype
import jneqsim.neqsim.processSimulation.mechanicalDesign.compressor
import jneqsim.neqsim.processSimulation.processEquipment
import jneqsim.neqsim.processSimulation.processEquipment.stream
import jneqsim.neqsim.thermo.system
import typing



class AntiSurge(java.io.Serializable):
    def __init__(self): ...
    def equals(self, object: typing.Any) -> bool: ...
    def getCurrentSurgeFraction(self) -> float: ...
    def getSurgeControlFactor(self) -> float: ...
    def hashCode(self) -> int: ...
    def isActive(self) -> bool: ...
    def isSurge(self) -> bool: ...
    def setActive(self, boolean: bool) -> None: ...
    def setCurrentSurgeFraction(self, double: float) -> None: ...
    def setSurge(self, boolean: bool) -> None: ...
    def setSurgeControlFactor(self, double: float) -> None: ...

class CompressorChartGenerator:
    def __init__(self, compressor: 'Compressor'): ...
    def generateCompressorChart(self, string: typing.Union[java.lang.String, str]) -> 'CompressorChart': ...

class CompressorChartInterface(java.lang.Cloneable):
    def addCurve(self, double: float, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]) -> None: ...
    def equals(self, object: typing.Any) -> bool: ...
    def getFlow(self, double: float, double2: float, double3: float) -> float: ...
    def getHeadUnit(self) -> java.lang.String: ...
    def getPolytropicEfficiency(self, double: float, double2: float) -> float: ...
    def getPolytropicHead(self, double: float, double2: float) -> float: ...
    def getSpeed(self, double: float, double2: float) -> int: ...
    def getStoneWallCurve(self) -> 'StoneWallCurve': ...
    def getSurgeCurve(self) -> 'SurgeCurve': ...
    def hashCode(self) -> int: ...
    def isUseCompressorChart(self) -> bool: ...
    def plot(self) -> None: ...
    def setCurves(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray4: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray5: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> None: ...
    def setHeadUnit(self, string: typing.Union[java.lang.String, str]) -> None: ...
    def setReferenceConditions(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def setStoneWallCurve(self, stoneWallCurve: 'StoneWallCurve') -> None: ...
    def setSurgeCurve(self, surgeCurve: 'SurgeCurve') -> None: ...
    def setUseCompressorChart(self, boolean: bool) -> None: ...
    def setUseRealKappa(self, boolean: bool) -> None: ...
    def useRealKappa(self) -> bool: ...

class CompressorCurve(java.io.Serializable):
    flow: typing.MutableSequence[float] = ...
    head: typing.MutableSequence[float] = ...
    polytropicEfficiency: typing.MutableSequence[float] = ...
    speed: float = ...
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, double: float, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]): ...
    def equals(self, object: typing.Any) -> bool: ...
    def hashCode(self) -> int: ...

class CompressorInterface(jneqsim.neqsim.processSimulation.processEquipment.ProcessEquipmentInterface, jneqsim.neqsim.processSimulation.processEquipment.TwoPortInterface):
    def equals(self, object: typing.Any) -> bool: ...
    def getAntiSurge(self) -> AntiSurge: ...
    def getDistanceToSurge(self) -> float: ...
    def getEnergy(self) -> float: ...
    def getIsentropicEfficiency(self) -> float: ...
    def getMaximumSpeed(self) -> float: ...
    def getMinimumSpeed(self) -> float: ...
    def getPolytropicEfficiency(self) -> float: ...
    def hashCode(self) -> int: ...
    def setIsentropicEfficiency(self, double: float) -> None: ...
    def setMaximumSpeed(self, double: float) -> None: ...
    def setMinimumSpeed(self, double: float) -> None: ...
    def setPolytropicEfficiency(self, double: float) -> None: ...

class CompressorPropertyProfile(java.io.Serializable):
    def __init__(self): ...
    def addFluid(self, systemInterface: jneqsim.neqsim.thermo.system.SystemInterface) -> None: ...
    def getFluid(self) -> java.util.ArrayList[jneqsim.neqsim.thermo.system.SystemInterface]: ...
    def isActive(self) -> bool: ...
    def setActive(self, boolean: bool) -> None: ...
    def setFluid(self, arrayList: java.util.ArrayList[jneqsim.neqsim.thermo.system.SystemInterface]) -> None: ...

class StoneWallCurve(java.io.Serializable):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray]): ...
    def equals(self, object: typing.Any) -> bool: ...
    def getStoneWallFlow(self, double: float) -> float: ...
    def hashCode(self) -> int: ...
    def isStoneWall(self, double: float, double2: float) -> bool: ...
    def setCurve(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]) -> None: ...

class SurgeCurve(java.io.Serializable):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray]): ...
    def equals(self, object: typing.Any) -> bool: ...
    def getSurgeFlow(self, double: float) -> float: ...
    def hashCode(self) -> int: ...
    def isSurge(self, double: float, double2: float) -> bool: ...
    def setCurve(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]) -> None: ...

class Compressor(jneqsim.neqsim.processSimulation.processEquipment.TwoPortEquipment, CompressorInterface):
    thermoSystem: jneqsim.neqsim.thermo.system.SystemInterface = ...
    dH: float = ...
    inletEnthalpy: float = ...
    pressure: float = ...
    isentropicEfficiency: float = ...
    polytropicEfficiency: float = ...
    usePolytropicCalc: bool = ...
    powerSet: bool = ...
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, boolean: bool): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str]): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str], boolean: bool): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str], streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface): ...
    @typing.overload
    def __init__(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface): ...
    def copy(self) -> 'Compressor': ...
    def displayResult(self) -> None: ...
    def equals(self, object: typing.Any) -> bool: ...
    def findOutPressure(self, double: float, double2: float, double3: float) -> float: ...
    def generateCompressorCurves(self) -> None: ...
    def getAntiSurge(self) -> AntiSurge: ...
    def getCompressionRatio(self) -> float: ...
    def getCompressorChart(self) -> CompressorChartInterface: ...
    def getDistanceToSurge(self) -> float: ...
    def getEnergy(self) -> float: ...
    def getEntropyProduction(self, string: typing.Union[java.lang.String, str]) -> float: ...
    def getExergyChange(self, string: typing.Union[java.lang.String, str], double: float) -> float: ...
    def getIsentropicEfficiency(self) -> float: ...
    def getMaximumSpeed(self) -> float: ...
    def getMechanicalDesign(self) -> jneqsim.neqsim.processSimulation.mechanicalDesign.compressor.CompressorMechanicalDesign: ...
    def getMinimumSpeed(self) -> float: ...
    def getNumberOfCompressorCalcSteps(self) -> int: ...
    def getOutTemperature(self) -> float: ...
    def getOutletPressure(self) -> float: ...
    def getPolytropicEfficiency(self) -> float: ...
    def getPolytropicExponent(self) -> float: ...
    def getPolytropicFluidHead(self) -> float: ...
    @typing.overload
    def getPolytropicHead(self) -> float: ...
    @typing.overload
    def getPolytropicHead(self, string: typing.Union[java.lang.String, str]) -> float: ...
    def getPolytropicHeadMeter(self) -> float: ...
    def getPolytropicMethod(self) -> java.lang.String: ...
    @typing.overload
    def getPower(self) -> float: ...
    @typing.overload
    def getPower(self, string: typing.Union[java.lang.String, str]) -> float: ...
    def getPropertyProfile(self) -> CompressorPropertyProfile: ...
    def getResultTable(self) -> typing.MutableSequence[typing.MutableSequence[java.lang.String]]: ...
    def getSpeed(self) -> float: ...
    def getThermoSystem(self) -> jneqsim.neqsim.thermo.system.SystemInterface: ...
    def getTotalWork(self) -> float: ...
    def hashCode(self) -> int: ...
    def isStoneWall(self, double: float, double2: float) -> bool: ...
    def isSurge(self, double: float, double2: float) -> bool: ...
    def isUseGERG2008(self) -> bool: ...
    def isUseRigorousPolytropicMethod(self) -> bool: ...
    @typing.overload
    def run(self) -> None: ...
    @typing.overload
    def run(self, uUID: java.util.UUID) -> None: ...
    def runController(self, double: float, uUID: java.util.UUID) -> None: ...
    @typing.overload
    def runTransient(self, double: float) -> None: ...
    @typing.overload
    def runTransient(self, double: float, uUID: java.util.UUID) -> None: ...
    def setAntiSurge(self, antiSurge: AntiSurge) -> None: ...
    def setCompressionRatio(self, double: float) -> None: ...
    def setCompressorChart(self, compressorChart: 'CompressorChart') -> None: ...
    def setInletStream(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface) -> None: ...
    def setIsentropicEfficiency(self, double: float) -> None: ...
    def setMaximumSpeed(self, double: float) -> None: ...
    def setMinimumSpeed(self, double: float) -> None: ...
    def setNumberOfCompressorCalcSteps(self, int: int) -> None: ...
    def setOutTemperature(self, double: float) -> None: ...
    @typing.overload
    def setOutletPressure(self, double: float) -> None: ...
    @typing.overload
    def setOutletPressure(self, double: float, string: typing.Union[java.lang.String, str]) -> None: ...
    def setPolytropicEfficiency(self, double: float) -> None: ...
    def setPolytropicHeadMeter(self, double: float) -> None: ...
    def setPolytropicMethod(self, string: typing.Union[java.lang.String, str]) -> None: ...
    def setPower(self, double: float) -> None: ...
    @typing.overload
    def setPressure(self, double: float) -> None: ...
    @typing.overload
    def setPressure(self, double: float, string: typing.Union[java.lang.String, str]) -> None: ...
    def setPropertyProfile(self, compressorPropertyProfile: CompressorPropertyProfile) -> None: ...
    def setSpeed(self, double: float) -> None: ...
    def setUseGERG2008(self, boolean: bool) -> None: ...
    def setUsePolytropicCalc(self, boolean: bool) -> None: ...
    def setUseRigorousPolytropicMethod(self, boolean: bool) -> None: ...
    def solveAntiSurge(self) -> None: ...
    def solveEfficiency(self, double: float) -> float: ...
    def toJson(self) -> java.lang.String: ...
    def useOutTemperature(self, boolean: bool) -> None: ...
    def usePolytropicCalc(self) -> bool: ...

class CompressorChart(CompressorChartInterface, java.io.Serializable):
    def __init__(self): ...
    def addCurve(self, double: float, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]) -> None: ...
    def addSurgeCurve(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray]) -> None: ...
    def checkStoneWall(self, double: float, double2: float) -> bool: ...
    def checkSurge1(self, double: float, double2: float) -> bool: ...
    def checkSurge2(self, double: float, double2: float) -> bool: ...
    def equals(self, object: typing.Any) -> bool: ...
    def fitReducedCurve(self) -> None: ...
    def getFlow(self, double: float, double2: float, double3: float) -> float: ...
    def getHeadUnit(self) -> java.lang.String: ...
    def getMaxSpeedCurve(self) -> float: ...
    def getMinSpeedCurve(self) -> float: ...
    def getPolytropicEfficiency(self, double: float, double2: float) -> float: ...
    def getPolytropicHead(self, double: float, double2: float) -> float: ...
    def getSpeed(self, double: float, double2: float) -> int: ...
    def getStoneWallCurve(self) -> StoneWallCurve: ...
    def getSurgeCurve(self) -> SurgeCurve: ...
    def hashCode(self) -> int: ...
    def isUseCompressorChart(self) -> bool: ...
    def plot(self) -> None: ...
    def polytropicEfficiency(self, double: float, double2: float) -> float: ...
    def setCurves(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray4: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray5: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> None: ...
    def setHeadUnit(self, string: typing.Union[java.lang.String, str]) -> None: ...
    def setMaxSpeedCurve(self, double: float) -> None: ...
    def setMinSpeedCurve(self, double: float) -> None: ...
    def setReferenceConditions(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def setStoneWallCurve(self, stoneWallCurve: StoneWallCurve) -> None: ...
    def setSurgeCurve(self, surgeCurve: SurgeCurve) -> None: ...
    def setUseCompressorChart(self, boolean: bool) -> None: ...
    def setUseRealKappa(self, boolean: bool) -> None: ...
    def useRealKappa(self) -> bool: ...

class CompressorChartAlternativeMapLookup(CompressorChartInterface, java.io.Serializable):
    def __init__(self): ...
    def addCurve(self, double: float, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[float], jpype.JArray]) -> None: ...
    def addSurgeCurve(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray]) -> None: ...
    @typing.overload
    @staticmethod
    def bisect_left(doubleArray: typing.Union[typing.List[float], jpype.JArray], double2: float) -> int: ...
    @typing.overload
    @staticmethod
    def bisect_left(doubleArray: typing.Union[typing.List[float], jpype.JArray], double2: float, int: int, int2: int) -> int: ...
    def checkStoneWall(self, double: float, double2: float) -> bool: ...
    def checkSurge1(self, double: float, double2: float) -> bool: ...
    def checkSurge2(self, double: float, double2: float) -> bool: ...
    def getClosestRefSpeeds(self, double: float) -> java.util.ArrayList[float]: ...
    def getCurveAtRefSpeed(self, double: float) -> CompressorCurve: ...
    def getFlow(self, double: float, double2: float, double3: float) -> float: ...
    def getGearRatio(self) -> float: ...
    def getHeadUnit(self) -> java.lang.String: ...
    def getPolytropicEfficiency(self, double: float, double2: float) -> float: ...
    def getPolytropicHead(self, double: float, double2: float) -> float: ...
    def getSpeed(self, double: float, double2: float) -> int: ...
    def getStoneWallCurve(self) -> StoneWallCurve: ...
    def getSurgeCurve(self) -> SurgeCurve: ...
    def isUseCompressorChart(self) -> bool: ...
    @staticmethod
    def main(stringArray: typing.Union[typing.List[java.lang.String], jpype.JArray]) -> None: ...
    def plot(self) -> None: ...
    def polytropicEfficiency(self, double: float, double2: float) -> float: ...
    def setCurves(self, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[float], jpype.JArray], doubleArray3: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray4: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], doubleArray5: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> None: ...
    def setGearRatio(self, double: float) -> None: ...
    def setHeadUnit(self, string: typing.Union[java.lang.String, str]) -> None: ...
    def setReferenceConditions(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def setStoneWallCurve(self, stoneWallCurve: StoneWallCurve) -> None: ...
    def setSurgeCurve(self, surgeCurve: SurgeCurve) -> None: ...
    def setUseCompressorChart(self, boolean: bool) -> None: ...
    def setUseRealKappa(self, boolean: bool) -> None: ...
    def useRealKappa(self) -> bool: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("jneqsim.neqsim.processSimulation.processEquipment.compressor")``.

    AntiSurge: typing.Type[AntiSurge]
    Compressor: typing.Type[Compressor]
    CompressorChart: typing.Type[CompressorChart]
    CompressorChartAlternativeMapLookup: typing.Type[CompressorChartAlternativeMapLookup]
    CompressorChartGenerator: typing.Type[CompressorChartGenerator]
    CompressorChartInterface: typing.Type[CompressorChartInterface]
    CompressorCurve: typing.Type[CompressorCurve]
    CompressorInterface: typing.Type[CompressorInterface]
    CompressorPropertyProfile: typing.Type[CompressorPropertyProfile]
    StoneWallCurve: typing.Type[StoneWallCurve]
    SurgeCurve: typing.Type[SurgeCurve]
