
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import java.util
import jneqsim.neqsim.processSimulation.mechanicalDesign.compressor
import jneqsim.neqsim.processSimulation.processEquipment
import jneqsim.neqsim.processSimulation.processEquipment.compressor
import jneqsim.neqsim.processSimulation.processEquipment.stream
import jneqsim.neqsim.thermo.system
import typing



class GasTurbine(jneqsim.neqsim.processSimulation.processEquipment.TwoPortEquipment):
    thermoSystem: jneqsim.neqsim.thermo.system.SystemInterface = ...
    airStream: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface = ...
    airCompressor: jneqsim.neqsim.processSimulation.processEquipment.compressor.Compressor = ...
    combustionpressure: float = ...
    power: float = ...
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str]): ...
    @typing.overload
    def __init__(self, string: typing.Union[java.lang.String, str], streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface): ...
    @typing.overload
    def __init__(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface): ...
    def calcIdealAirFuelRatio(self) -> float: ...
    def getHeat(self) -> float: ...
    def getMechanicalDesign(self) -> jneqsim.neqsim.processSimulation.mechanicalDesign.compressor.CompressorMechanicalDesign: ...
    def getPower(self) -> float: ...
    @typing.overload
    def run(self) -> None: ...
    @typing.overload
    def run(self, uUID: java.util.UUID) -> None: ...
    def setInletStream(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("jneqsim.neqsim.processSimulation.processEquipment.powerGeneration")``.

    GasTurbine: typing.Type[GasTurbine]
